/*
project: brushes.js
author: Jim Schubert
url: https://github.com/jimschubert/brushes.js

The MIT License

Copyright (c) 2011 Jim Schubert

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*//**  @define {boolean} */DEBUG_BRUSH=!1,function(a){var b=function(a){this.init(a)};b.prototype={DEBUG:DEBUG_BRUSH,_debug:function(a){this.DEBUG&&console&&typeof console.log=="function"&&console.log(a)},className:"Brush",defaults:{WEIGHT:.1,BRUSH_SIZE:1,BRUSH_PRESSURE:1,COLOR:[0,0,0],RANDOM_COLORS:!1},options:{weight:.1,size:1,pressure:1,color:[0,0,0],randomize:!1},context:null,prevMouseX:null,prevMouseY:null,points:new Array,count:0,_strokeStyle:function(a){this._mergeOptions(a||{});var b=this.options,c=b.color[0],d=b.color[1],e=b.color[2],f=b.weight*b.pressure;if(b.randomize){var g=Math.random,h=Math.floor,i="".concat("rgba(",h(g()*c),",",h(g()*d),",",h(g()*e),",",f,")");return i}var j="".concat("rgba(",c,",",d,",",e,",",f,")");return j},init:function(a){if(!a||!a.context){var b=this.window&&this.window.document&&this.window.document.getElementsByTagName;if(b){var c=b("canvas")?b("canvas")[0]:null;c&&(this.context=c.getContext("2d"))}}this.reset(a),this._mergeOptions(a),typeof this._init=="function"&&this._init(a)},reset:function(a){if(a||this.options)a=a||{},this.context=a.context||this.context,this.options.size=a.size||this.defaults.BRUSH_SIZE,this.options.pressure=a.pressure||this.defaults.BRUSH_PRESSURE,this.options.color=a.color||this.defaults.COLOR,this.options.randomize=a.randomize||this.defaults.RANDOM_COLORS,this.options.weight=a.weight||this.defaults.WEIGHT,this.prevMouseX=null,this.prevMouseY=null,this.points=new Array,this.count=0;this._setContextDefaults()},destroy:function(){},strokeEnd:function(){this.context.closePath()},strokeStart:function(a,b){this.prevMouseX=a,this.prevMouseY=b},stroke:function(a,b){var c=this.context;c.beginPath(),c.lineWidth=this.options.size,c.moveTo(this.prevMouseX,this.prevMouseY),c.lineTo(a,b),c.stroke(),c.fill(),c.closePath(),this.prevMouseX=a,this.prevMouseY=b},pointDistance:function(a,b,c,d){return Math.sqrt((a-=c)*a+(b-=d)*b)},_setContextDefaults:function(){if(!this.context)return;var a=this._strokeStyle();this.context.fillStyle=a,this.context.font="10px sans-serif",this.context.globalAlpha=1,this.context.globalCompositeOperation="source-over",this.context.lineCap="square",this.context.lineJoin="miter",this.context.lineWidth=this.defaults.BRUSH_SIZE*this.defaults.BRUSH_PRESSURE,this.context.miterLimit=10,this.context.shadowBlur=0,this.context.shadowColor="rgba(0,0,0,0.0)",this.context.shadowOffsetX=0,this.context.shadowOffsetY=0,this.context.strokeStyle=a,this.context.textAlign="start",this.context.textBaseline="alphabetic"},_eachPoint:function(a,b){if(typeof b!="function")return null;if(a)for(var c=this.points.length;c>=0;c--){var d=this.points[c];typeof d!="undefined"&&b(d)}else for(var e=0;e<=this.points.length;e++){var d=this.points[e];typeof d!="undefined"&&b(d)}return this.points},_mergeOptions:function(a){var b=this;if("object"==typeof a)for(p in a)b.options[p]=a[p]}};var c=function(a){var b=this;b.className="pencil",a=a||{},a.weight=.5,b.init(a)};c.prototype=new b,c.prototype._init=function(a){var b=this;b.context&&(b.context.lineCap="square",b.context.lineJoin="miter")};var d=function(a){var b=this;b.className="pen",a=a||{},a.weight=3,b.init(a)};d.prototype=new b,d.prototype._init=function(a){var b=this;b.context&&(b.context.lineCap="block",b.context.lineJoin="round")};var e=function(a){var b=this;b.className="marker",a=a||{},a.weight=5,b.init(a)};e.prototype=new b,e.prototype._init=function(a){var b=this;b.context&&(b.context.lineCap="round",b.context.lineJoin="bevel")},_charcoal=function(a){var b=this;b.className="charcoal",b.data=a||{},b.data.weight=5,b.init(a)},_charcoal.prototype=new b,_charcoal.prototype._init=function(a){var b=this,c=b.context;c&&c.globalCompositeOperation&&(c.globalCompositeOperation="darker")},_charcoal.prototype.stroke=function(a,b){var c=this,d=c.context;d.lineWidth=c.options.size,d.strokeStyle=c._strokeStyle({weight:.05}),c.points.push([a,b]);var e=Math.random()%80;for(var f=e/2*7;f>=0;f--)d.beginPath(),d.lineCap="butt",d.lineJoin="bevel",d.moveTo(a+f,b-f),d.lineWidth=c.options.size*f,d.lineTo(a,b+c.options.pressure*f),d.stroke(),c.count++};var f=function(a){var b=this;b.className="stars",a=a||{},a.weight=5,b.init(a)};f.prototype=new b,f.prototype._init=function(a){var b=this,c=b.context;c&&c.globalCompositeOperation&&(c.globalCompositeOperation="source-over"),c&&(c.lineCap="square",c.lineJoin="miter")},f.prototype.stroke=function(a,b){var c=this;c.context.lineWidth=c.options.size,c.context.strokeStyle=c._strokeStyle({weight:c.options.weight});if(c.pointDistance(a,b,c.prevMouseX,c.prevMouseY)<c.options.size*1.3)return;c.context.fillStyle=c._strokeStyle({randomize:c.options.randomize});var d=Math.PI/3,e=Math.cos(d)*a+Math.sin(d)*b;c.points.push([a,b]),c.count++;var f=2*Math.PI/5,g=2;c.context.save(),c.context.translate(a,b),c.context.rotate(e),c.context.beginPath();var h=Math.cos(0),i=Math.sin(0);c.context.moveTo(h,i);for(var j=1;j<7;j++)h=Math.cos(g*f),i=Math.sin(g*f),c.context.lineTo(h,i),g=(g+2)%5;c.context.fill(),c.context.stroke(),c.context.closePath(),c.context.restore(),c.prevMouseX=a,c.prevMouseY=b};var g=function(a){var b=this;b.className="boxes",a=a||{},a.weight=.5,b.init(a)};g.prototype=new b,g.prototype._init=function(a){var b=this;b.context&&b.context.globalCompositeOperation&&(b.context.globalCompositeOperation="source-over"),b.context&&(b.context.lineCap="square",b.context.lineJoin="miter")},g.prototype.stroke=function(a,b){var c=this;c.context.lineWidth=2,c.context.strokeStyle=c._strokeStyle({weight:c.options.weight});if(c.pointDistance(a,b,c.prevMouseX,c.prevMouseY)<c.options.size*1.5)return;c.points.push([a,b]),c.count++;var d=Math.PI/3,e=Math.cos(d)*a+Math.sin(d)*b;c.context.fillStyle=c._strokeStyle({randomize:c.options.randomize}),c.context.save();var f=3+c.options.size*c.options.pressure,g=2+c.options.size*c.options.pressure;c.context.translate(a,b),c.context.rotate(e),c.context.beginPath(),c.context.moveTo(-f,g),c.context.lineTo(f,g),c.context.lineTo(f,-g),c.context.lineTo(-f,-g),c.context.lineTo(-f,g),c.context.fill(),c.context.stroke(),c.context.closePath(),c.context.restore(),c.prevMouseX=a,c.prevMouseY=b};var h=function(a){var b=this;b.className="hearts",a=a||{},a.weight=.5,b.init(a)};h.prototype=new b,h.prototype._init=function(a){var b=this;b.context&&(b.context.lineCap="round",b.context.lineJoin="round",b.context.strokeStyle=b._strokeStyle({weight:b.options.weight}),b.context.fillStyle=b._strokeStyle({randomize:b.options.randomize}),b.context.lineWidth=2)},h.prototype.stroke=function(a,b){var c=this;if(c.pointDistance(a,b,c.prevMouseX,c.prevMouseY)<c.options.size*1.5)return;c.points.push([a,b]),c.count++;var d=45;c.context.save();var e=5+c.options.size*c.options.pressure;c.context.translate(a,b),c.context.rotate(Math.PI*-120/180),c.context.beginPath(),c.context.moveTo(-e,0),c.context.arc(0,0,e,0,Math.PI,!1),c.context.lineTo(e,0),c.context.arc(e,-e,e,Math.PI*90/180,Math.PI*270/180,!0),c.context.lineTo(e,-e*2),c.context.lineTo(-e,-e*2),c.context.lineTo(-e,0),c.context.fill(),c.context.closePath(),c.context.restore(),c.prevMouseX=a,c.prevMouseY=b};var i=function(a){var b=this;b.className="blood",a=a||{},a.weight=1.5,b.init(a)};i.prototype=new b,i.prototype._init=function(a){var b=this;b.context&&b.context.globalCompositeOperation&&(b.context.globalCompositeOperation="darker"),b.context&&(b.context.lineCap="round",b.context.lineJoin="bevel")},i.prototype.stroke=function(a,b){var c=this;c.context.fillStyle=c._strokeStyle({randomize:c.options.randomize}),c.context.strokeStyle=c._strokeStyle({randomize:!!c.options.randomize}),c.context.lineWidth=1.5*c.options.size+c.options.pressure,c.context.beginPath(),c.context.moveTo(c.prevMouseX,c.prevMouseY),c.context.lineTo(a,b),c.context.fill(),c.context.stroke(),c.context.closePath();var d=(new Date).getMilliseconds()%40;if(c.pointDistance(a,b,c.prevMouseX,c.prevMouseY)>d){if(c.options.pressure>0){var e=(new Date).getMilliseconds()%640;c.context.beginPath(),c.context.moveTo(a,b);var f=b+e;f>c.context.canvas.height&&(f=b+Math.ceil(Math.random)),c.context.lineTo(a,f),c.context.fill(),c.context.stroke(),c.context.closePath()}c.points.push([a,b]),c.count++}c.prevMouseX=a,c.prevMouseY=b};var j={};j.pencil=c,j.pen=d,j.marker=e,j.charcoal=_charcoal,j.stars=f,j.boxes=g,j.hearts=h,j.blood=i,j.Brush=b,"object"==typeof module&&"object"==typeof module.exports&&(module.exports.Brushes=j,module.exports.Brush=b),Brushes=j}(this)